ea4002ed8b8851d2ad259fa6fff17607dfc62135
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 "
137
138 broken="$broken
139 7s-struct-short
140 "
141
142 set +e
143 expect=$(echo $broken | wc -w)
144 pass=0
145 fail=0
146 total=0
147 for t in $tests; do
148     if [ -z "${t/[012][0-9]-*/}" ]; then
149         LIBC=c-mini
150         MESCCLIBS="-l c-mini"
151     elif [ -z "${t/8[0-9]-*/}" ]; then
152         LIBC=c+tcc
153         MESCCLIBS="-l c+tcc"
154     else
155         LIBC=c
156         MESCCLIBS=
157     fi
158     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
159     r=$?
160     total=$((total+1))
161     if [ $r = 0 ]; then
162         echo $t: [OK]
163         pass=$((pass+1))
164     else
165         echo $t: [FAIL]
166         fail=$((fail+1))
167     fi
168 done
169
170 tests="
171 00_assignment
172 01_comment
173 02_printf
174 03_struct
175 04_for
176 05_array
177 06_case
178 07_function
179 08_while
180 09_do_while
181
182 10_pointer
183 11_precedence
184 12_hashdefine
185 13_integer_literals
186 14_if
187 15_recursion
188 16_nesting
189 17_enum
190 18_include
191 19_pointer_arithmetic
192
193 20_pointer_comparison
194 21_char_array
195 22_floating_point
196 23_type_coercion
197 24_math_library
198 25_quicksort
199 26_character_constants
200 27_sizeof
201 28_strings
202 29_array_address
203
204 30_hanoi
205 31_args
206 32_led
207 33_ternary_op
208 34_array_assignment
209 35_sizeof
210 36_array_initialisers
211 37_sprintf
212 38_multiple_array_index
213 39_typedef
214
215 40_stdio
216 41_hashif
217 42_function_pointer
218 43_void_param
219 44_scoped_declarations
220 45_empty_for
221 46_grep
222 47_switch_return
223 48_nested_break
224 49_bracket_evaluation
225
226 50_logical_second_arg
227 51_static
228 52_unnamed_enum
229 54_goto
230 55_lshift_type
231 "
232
233 broken="$broken
234 18_include
235
236 22_floating_point
237 23_type_coercion
238 24_math_library
239 26_character_constants
240 27_sizeof
241 28_strings
242
243 31_args
244 34_array_assignment
245 37_sprintf
246 39_typedef
247
248 40_stdio
249 42_function_pointer
250 46_grep
251 49_bracket_evaluation
252 55_lshift_type
253 "
254
255 #22_floating_point       ; float
256 #23_type_coercion        ; float
257 #24_math_library         ; float
258 #27_sizeof               ; float
259 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
260 #30_hanoi                ; fails with GCC
261 #34_array_assignment     ; fails with GCC
262 #37_sprintf              ; integer formatting unsupported
263 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
264
265 #40_stdio                ; f* functions
266 #42_function_pointer     ; f* functions
267 #46_grep                 ; f* functions
268 #49_bracket_evaluation   ; float
269
270
271
272 expect=$(echo $broken | wc -w)
273 for t in $tests; do
274     if [ ! -f scaffold/tinycc/"$t.c" ]; then
275         echo ' [SKIP]'
276         continue;
277     fi
278     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
279     r=$?
280     total=$((total+1))
281     if [ $r = 0 ]; then
282         echo $t: [OK]
283         pass=$((pass+1))
284     else
285         echo $t: [FAIL]
286         fail=$((fail+1))
287     fi
288 done
289 [ $expect != 0 ] && echo "expect: $expect"
290 [ $fail != 0 ] && echo "failed: $fail"
291 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
292 echo "passed: $pass"
293 echo "total:  $total"
294 if [ $fail != 0 -a $fail -gt $expect ]; then
295     echo FAILED: $fail/$total
296     exit 1
297 elif [ $fail != 0 ]; then
298     echo PASS: $pass/$total
299 else
300     echo PASS: $total
301 fi